Index: trunk/SophyaPI/PI/pistdwdggen.cc
===================================================================
--- trunk/SophyaPI/PI/pistdwdggen.cc	(revision 323)
+++ trunk/SophyaPI/PI/pistdwdggen.cc	(revision 329)
@@ -22,5 +22,5 @@
 //--
 //++
-// PILabel(PIContainerGen* par, char* nom, int sx=10, int sy=10, int px=0, int py=0)
+// PILabel(PIContainerGen* par, const char* nom, int sx=10, int sy=10, int px=0, int py=0)
 //	Création d'un objet PILabel ayant un contenu (étiquette) identique à "nom".
 // void SetLabel(string const& lab)
@@ -31,5 +31,5 @@
 
 
-PILabelGen::PILabelGen(PIContainerGen *par, char *nom,
+PILabelGen::PILabelGen(PIContainerGen *par, const char *nom,
                          int sx, int sy, int px, int py)
 : PIWdg(par, nom, sx, sy, px, py)
@@ -61,5 +61,5 @@
 //--
 //++
-// PIButton(PIContainerGen* par, char* nom, PIMessage msg, int sx=10, int sy=10, int px=0, int py=0)
+// PIButton(PIContainerGen* par, const char* nom, PIMessage msg, int sx=10, int sy=10, int px=0, int py=0)
 //	Création d'un objet PIButton avec une étiquette identique à "nom".
 // void SetLabel(string const& lab)
@@ -69,5 +69,5 @@
 
 
-PIButtonGen::PIButtonGen(PIContainerGen *par, char *nom, PIMessage msg,
+PIButtonGen::PIButtonGen(PIContainerGen *par, const char *nom, PIMessage msg,
                          int sx, int sy, int px, int py)
 : PIWdg(par, nom, sx, sy, px, py)
@@ -105,7 +105,7 @@
 //--
 //++
-//  PIText(PIContainerGen* par, char* nom, int sx=10, int sy=10, int px=0, int py=0)
+//  PIText(PIContainerGen* par, const char* nom, int sx=10, int sy=10, int px=0, int py=0)
 //	Création d'un objet PIText.
-//  PIText(PIContainerGen* par, char* nom, bool vsb, bool hsb, -
+//  PIText(PIContainerGen* par, const char* nom, bool vsb, bool hsb, -
 //  int sx=10, int sy=10, int px=0, int py=0)
 //	Création d'un objet PIText multiligne, muni d'ascenseurs 
@@ -121,10 +121,10 @@
 //--
 
-PITextGen::PITextGen(PIContainerGen *par, char *nom,
-                         int sx, int sy, int px, int py)
-: PIWdg(par, nom, sx, sy, px, py)
-{}
-
-PITextGen::PITextGen(PIContainerGen *par, char *nom, bool vsb, bool hsb, 
+PITextGen::PITextGen(PIContainerGen *par, const char *nom,
+                         int sx, int sy, int px, int py)
+: PIWdg(par, nom, sx, sy, px, py)
+{}
+
+PITextGen::PITextGen(PIContainerGen *par, const char *nom, bool vsb, bool hsb, 
                          int sx, int sy, int px, int py)
 : PIWdg(par, nom, sx, sy, px, py)
@@ -139,5 +139,5 @@
 /************* PICheckBoxGen ************/
 
-PICheckBoxGen::PICheckBoxGen(PIContainerGen *par, char *nom, PIMessage msg,
+PICheckBoxGen::PICheckBoxGen(PIContainerGen *par, const char *nom, PIMessage msg,
                          int sx, int sy, int px, int py)
 : PIWdg(par, nom, sx, sy, px, py)
@@ -171,5 +171,5 @@
 //--
 //++
-// PICheckBox(PIContainerGen* par, char* nom,  PIMessage msg, int sx=10, int sy=10, int px=0, int py=0);
+// PICheckBox(PIContainerGen* par, const char* nom,  PIMessage msg, int sx=10, int sy=10, int px=0, int py=0);
 //	Création d'un objet PICheckBox.
 // void SetState(bool st=false)
@@ -204,5 +204,5 @@
 //--
 //++
-// PIScale(PIContainerGen* par, char* nom, PIMessage msg, int dir=kSDirLtoR, int sx=100, int sy=10, int px=0, int py=0)
+// PIScale(PIContainerGen* par, const char* nom, PIMessage msg, int dir=kSDirLtoR, int sx=100, int sy=10, int px=0, int py=0)
 //	Création d'un objet PIScale. "dir" indique la direction et le sens d'affichage et peut
 //	prendre les valeurs "kSDirLtoR" (gauche à droite), "kSDirRtoL" (droite à gauche),
@@ -219,5 +219,5 @@
 
 
-PIScaleGen::PIScaleGen(PIContainerGen *par, char *nom, PIMessage msg, 
+PIScaleGen::PIScaleGen(PIContainerGen *par, const char *nom, PIMessage msg, 
                        int /*dir*/, int sx, int sy, int px, int py)
 : PIWdg(par, nom, sx, sy, px, py) 
@@ -255,5 +255,5 @@
 //--
 //++
-// PIScrollBar(PIContainerGen* par, char* nom, PIMessage msg, int dir=kSDirUpDown, int sx=10, int sy=100, int px=0, int py=0)
+// PIScrollBar(PIContainerGen* par, const char* nom, PIMessage msg, int dir=kSDirUpDown, int sx=10, int sy=100, int px=0, int py=0)
 //	Création d'un objet PIScrollBar. "dir" indique la direction et le sens d'affichage et peut
 //	prendre les valeurs "kSDirLtoR" (gauche à droite), "kSDirRtoL" (droite à gauche),
@@ -276,5 +276,5 @@
 //--
 
-PIScrollBarGen::PIScrollBarGen(PIContainerGen *par, char *nom, PIMessage msg, 
+PIScrollBarGen::PIScrollBarGen(PIContainerGen *par, const char *nom, PIMessage msg, 
                        int /*dir*/, int sx, int sy, int px, int py)
 : PIWdg(par, nom, sx, sy, px, py) 